\name{ttest.NnDd}
\alias{ttest.NnDd}
\alias{nndd_ttest}
\alias{predict.NnDd}
\alias{predict_fun_glm}
\alias{print.NnDd}
\alias{plot.NnDd}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ttest}
\description{
Performs a ttest on a \code{"NnDd"} object. The ttest is applied on only on the time span on which the NN are specified.}
\usage{
\method{ttest}{NnDd}(x, \dots)

nndd_ttest(ttest_data, indexes = c("year", "firm_id", "tg"), nn_time, \dots)

\method{predict}{NnDd}(object, prediction = c("Nn", "Dd"), newdata, \dots)

predict_fun_glm(pformula, family = "binomial", data)

\method{print}{NnDd}(x, digits = max(3, getOption("digits") - 3), \dots)

\method{plot}{NnDd}(x, data, \dots)


}
\arguments{
  \item{x, object}{an object of class \code{"NnDd"}}
  
  \item{ttest_data}{a data.frame containing the data on which the ttest should be performed on.}

\item{indexes}{a list containing the name of the time, group, treatment identifier, and the outcome variable #Fixme: last two not really necessary}
 
\item{nn_time}{a list containing the start timing and end timing for the NN estimation. The GLM is estimated at the end timing. However, it contains all regressor variables lagged in the given interval (start , end). 
}

\item{pformula}{
    a formula expression of the form \code{tg | outcome ~ x | z} where
    \code{tg} is the response and \code{z} regressor variable of the GLM. \code{outcome} is the response and \code{x} the regressor variable of the DD model.}
\item{prediction}{a list containing specifying which model should be applied for the prediction. If the list contains "Nn" the pscores of the GLM model are predicted. In the case of containing "Dd" the prediction of the linear difference in differences model is returned. Both predictions are returned if the list is specified as "Nn", "Dd".}

\item{newdata}{a data.frame containing the data on which the prediction should be based on.}

\item{family}{family of the GLM. #Fixme: not implemented in NnDd, but in predict.NnDd}

\item{digits}{see \code{\link{print}}}    

\item{data}{a data frame containing the variables occurring in the
    formulas such as time and group identifiers. The data has to be a panel.}
\item{\dots}{space for objects to be passed on}

}
\details{...}
\value{...}
\references{...}
\examples{x <- "Fix: me"
print(x)}
\keyword{ttest}